	.module nores.c
	.dbfile nores.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; #include <algconst.h>
; /************************ End of Includes ****************************/
; 
; /*************************** Constants ********************************/
; #define TABLE_LENGTH 400
; #define PAV_TURN	0x40
; #define PAV_STRAIGHT 0x80
; #define PAV_AFTER 0xFF
; 
; /************************ End of Constants ****************************/
; #pragma interrupt_handler PAV_isr
; /*************************** Prototypes *********************************/
; void STRAIGHTEN(void);
; void init_PA(void);
; void PAV_isr(void);
; void TURN_RIGHT(void);
; void TURN_LEFT(void);
; void TURN_AROUND(void);
; void PA_ON(void);
; void PA_OFF(void);
; /************************ End of Prototypes *****************************/
; 
; int counter;
; int speedr;
; int speedl;
; int done;
; 
; 
; void main(void)
; /****************************** Main ***********************************/
; {
; 	int irdr, irdl, irdc;
; 	int std;
; 	int diff;
; 	
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 	
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
; 	init_PA();
; 
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 	IRE_ON;
; 
; 	speedr = MAX_RIGHT;
; 	speedl = MAX_LEFT;
; 	
; 	counter=0;
; 
; 	START;
; 	
; 	while(1)
; 	{
; 
; 		std = (RIGHT_IR + LEFT_IR) / 2;
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 
; 		irdl=LEFT_IR;
; 		irdr=RIGHT_IR;
; 		irdc=CENTER_IR;
; 
; 		if ((irdr <= NOWALL) & ((irdc >= STOP) | (irdl >= WALL)))
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 		{
; 			TURN_RIGHT();
; 			STRAIGHTEN();
; 			STRAIGHTEN();
; 			STRAIGHTEN();
; 			STRAIGHTEN();
; 		}
; 		else if ((irdl <= NOWALL) & ((irdc >= STOP) | (irdr >= WALL)))
; 		{
; 			TURN_LEFT();
; 			STRAIGHTEN();
; 			STRAIGHTEN();
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 			STRAIGHTEN();
; 			STRAIGHTEN();
; 		}
; 		else if ((irdc >= STOP) & ((irdr >= STOP) & (irdl >= STOP)))
; 		{
; 			TURN_AROUND();
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; 			STRAIGHTEN();
; 			STRAIGHTEN();
; 			STRAIGHTEN();
; 			STRAIGHTEN();
; 		}
; 	
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 		if((irdr < IR_MIN+1) & (irdc < IR_MIN+1) & (irdl < IR_MIN+1))
; 		{
; 			motorp(RIGHT_MOTOR,0);
; 			motorp(LEFT_MOTOR,0);
; 			speedr=MAX_RIGHT;
; 			speedl=MAX_LEFT;
; 			START;
; 		}			 
; 
; 		if(FRONT_BUMP)
; 		{
; 			speedr=-MAX_RIGHT;
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; 			speedl=-MAX_LEFT;
; 			motorp(RIGHT_MOTOR, speedr);
; 			motorp(LEFT_MOTOR, speedl);
; 			wait(5 * DELAY_TIME);
; 			counter=TABLE_LENGTH-1;
; 		}
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; 				
; 		motorp(RIGHT_MOTOR, speedr);
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(DELAY_TIME);
; 	}
; }
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; 	
; 
; void TURN_RIGHT(void)
; {
; 			PA_ON();
; 			counter=1;
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; 			PACNT=PAV_STRAIGHT;
; 			done=0;
; 			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			while(done==0)
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; 			{
; 				asm("NOP");
; 			}
; 			counter=1;
; //			PACNT = PAV_TURN + 5;			
; 			PACNT = PAV_TURN;
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; 			done=0;
; 			motorp(RIGHT_MOTOR, 0);
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			while(done==0)
; 			{
; 				asm("NOP");
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; 			}
; 
; 			counter=1;
; 			PACNT = PAV_AFTER;
; 			done=0;			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; 			motorp(LEFT_MOTOR, MAX_LEFT);
; 			while(done==0)
; 			{
; 				asm("NOP");
; 			}
; 
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; 			motorp(RIGHT_MOTOR, 0);
; 			motorp(LEFT_MOTOR, 0);			
; 			PA_OFF();
; }
; 
; 
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
;  rMEM -> 2,x
;  func temp: 4,x - 8,x
;          ?temp -> 8,x
;          ?temp -> 10,x
;          ?temp -> 12,x
;          ?temp -> 14,x
;          ?temp -> 16,x
;          ?temp -> 18,x
;          ?temp -> 20,x
;          ?temp -> 22,x
;          ?temp -> 24,x
;          ?temp -> 26,x
;          ?temp -> 28,x
;          ?temp -> 30,x
;           diff -> 32,x
;            std -> 34,x
;           irdc -> 36,x
;           irdl -> 38,x
;           irdr -> 40,x
_main::
	jsr __enterb
	.byte 0x2a
	.dbfile nores.c
	.dbfunc main
	.dbline 40
	jsr _init_analog
	.dbline 41
	jsr _init_motortjp
	.dbline 42
	jsr _init_clocktjp
	.dbline 43
	jsr _init_PA
	.dbline 45
	ldab #7
	stab 0x7000
	.dbline 47
	ldd #75
	std _speedr
	.dbline 48
	ldd #100
	std _speedl
	.dbline 50
	ldd #0
	std _counter
L20:
	.dbline 52
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	jmp L24
L23:
	.dbline 57
	ldd #2
	jsr _analog
	std 4,x
	ldd #3
	jsr _analog
	std 6,x
	ldd 4,x
	addd 6,x
	ldy #2
	jsr __divi
	std 34,x
	.dbline 59
	ldd #3
	jsr _analog
	std 38,x
	.dbline 60
	ldd #2
	jsr _analog
	std 40,x
	.dbline 61
	ldd #7
	jsr _analog
	std 36,x
	.dbline 63
	ldd 40,x
	cpd #115
	bgt L31
	ldd #1
	std 30,x
	bra L32
L31:
	ldd #0
	std 30,x
L32:
	ldd 36,x
	cpd #127
	blt L33
	ldd #1
	std 28,x
	bra L34
L33:
	ldd #0
	std 28,x
L34:
	ldd 38,x
	cpd #122
	blt L35
	ldd #1
	std 26,x
	bra L36
L35:
	ldd #0
	std 26,x
L36:
	ldd 28,x
	oraa 26,x
	orab 27,x
	std 2,x
	ldd 30,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L26
	.dbline 65
	jsr _TURN_RIGHT
	.dbline 66
	jsr _STRAIGHTEN
	.dbline 67
	jsr _STRAIGHTEN
	.dbline 68
	jsr _STRAIGHTEN
	.dbline 69
	jsr _STRAIGHTEN
	.dbline 70
	jmp L27
L26:
	.dbline 71
	ldd 38,x
	cpd #115
	bgt L42
	ldd #1
	std 24,x
	bra L43
L42:
	ldd #0
	std 24,x
L43:
	ldd 36,x
	cpd #127
	blt L44
	ldd #1
	std 22,x
	bra L45
L44:
	ldd #0
	std 22,x
L45:
	ldd 40,x
	cpd #122
	blt L46
	ldd #1
	std 20,x
	bra L47
L46:
	ldd #0
	std 20,x
L47:
	ldd 22,x
	oraa 20,x
	orab 21,x
	std 2,x
	ldd 24,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L37
	.dbline 73
	jsr _TURN_LEFT
	.dbline 74
	jsr _STRAIGHTEN
	.dbline 75
	jsr _STRAIGHTEN
	.dbline 76
	jsr _STRAIGHTEN
	.dbline 77
	jsr _STRAIGHTEN
	.dbline 78
	bra L38
L37:
	.dbline 79
	ldd 36,x
	cpd #127
	blt L53
	ldd #1
	std 18,x
	bra L54
L53:
	ldd #0
	std 18,x
L54:
	ldd 40,x
	cpd #127
	blt L55
	ldd #1
	std 16,x
	bra L56
L55:
	ldd #0
	std 16,x
L56:
	ldd 38,x
	cpd #127
	blt L57
	ldd #1
	std 14,x
	bra L58
L57:
	ldd #0
	std 14,x
L58:
	ldd 16,x
	anda 14,x
	andb 15,x
	std 2,x
	ldd 18,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L48
	.dbline 81
	jsr _TURN_AROUND
	.dbline 82
	jsr _STRAIGHTEN
	.dbline 83
	jsr _STRAIGHTEN
	.dbline 84
	jsr _STRAIGHTEN
	.dbline 85
	jsr _STRAIGHTEN
	.dbline 86
L48:
L38:
L27:
	.dbline 88
	ldd 40,x
	cpd #89
	bge L64
	ldd #1
	std 12,x
	bra L65
L64:
	ldd #0
	std 12,x
L65:
	ldd 36,x
	cpd #89
	bge L66
	ldd #1
	std 10,x
	bra L67
L66:
	ldd #0
	std 10,x
L67:
	ldd 38,x
	cpd #89
	bge L68
	ldd #1
	std 8,x
	bra L69
L68:
	ldd #0
	std 8,x
L69:
	ldd 12,x
	anda 10,x
	andb 11,x
	anda 8,x
	andb 9,x
	cpd #0
	beq L59
	.dbline 90
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 91
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 92
	ldd #75
	std _speedr
	.dbline 93
	ldd #100
	std _speedl
L70:
	.dbline 94
L71:
	ldd #0
	jsr _analog
	cpd #120
	blt L70
	.dbline 95
L59:
	.dbline 97
	ldd #0
	jsr _analog
	cpd #38
	ble L73
	ldd #0
	jsr _analog
	cpd #120
	bge L73
	.dbline 99
	ldd #-75
	std _speedr
	.dbline 100
	ldd #-100
	std _speedl
	.dbline 101
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 102
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 103
	ldd #250
	jsr _wait
	.dbline 104
	ldd #399
	std _counter
	.dbline 105
L73:
	.dbline 107
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 108
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 109
	ldd #50
	jsr _wait
	.dbline 110
L24:
	.dbline 54
	jmp L23
L19:
	xgdx
	addd #42
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_TURN_RIGHT::
	.dbfunc TURN_RIGHT
	.dbline 116
	jsr _PA_ON
	.dbline 117
	ldd #1
	std _counter
	.dbline 118
	ldab #128
	stab 0x1027
	.dbline 119
	ldd #0
	std _done
	.dbline 121
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 122
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L77
L76:
		NOP

	.dbline 126
L77:
	.dbline 123
	ldd _done
	beq L76
	.dbline 127
	ldd #1
	std _counter
	.dbline 129
	ldab #64
	stab 0x1027
	.dbline 130
	ldd #0
	std _done
	.dbline 131
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 132
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L80
L79:
		NOP

	.dbline 136
L80:
	.dbline 133
	ldd _done
	beq L79
	.dbline 138
	ldd #1
	std _counter
	.dbline 139
	ldab #255
	stab 0x1027
	.dbline 140
	ldd #0
	std _done
	.dbline 141
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 142
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L83
L82:
		NOP

	.dbline 146
L83:
	.dbline 143
	ldd _done
	beq L82
	.dbline 148
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 149
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 150
	jsr _PA_OFF
	.dbline 151
L75:
	rts
;  IX -> 0,x
_TURN_LEFT::
	.dbfunc TURN_LEFT
	.dbline 157
; 
; void TURN_LEFT(void)
; {
; 			PA_ON();
	jsr _PA_ON
	.dbline 158
; 			counter=1;
	ldd #1
	std _counter
	.dbline 159
; 			PACNT=PAV_STRAIGHT;
	ldab #128
	stab 0x1027
	.dbline 160
; 			done=0;
	ldd #0
	std _done
	.dbline 162
; 			
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 163
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L87
L86:
		NOP

	.dbline 167
L87:
	.dbline 164
; 			while(done==0)
	ldd _done
	beq L86
	.dbline 169
; 			{
; 				asm("NOP");
; 			}
; 
; 			counter=1;
	ldd #1
	std _counter
	.dbline 170
; 			PACNT = PAV_TURN;			
	ldab #64
	stab 0x1027
	.dbline 171
; 			done=0;
	ldd #0
	std _done
	.dbline 172
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 173
; 			motorp(LEFT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L90
L89:
		NOP

	.dbline 177
L90:
	.dbline 174
; 			while(done==0)
	ldd _done
	beq L89
	.dbline 179
; 			{
; 				asm("NOP");
; 			}
; 			
; 			counter=1;
	ldd #1
	std _counter
	.dbline 180
; 			PACNT = PAV_AFTER;
	ldab #255
	stab 0x1027
	.dbline 181
; 			done=0;			
	ldd #0
	std _done
	.dbline 182
; 			motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 183
; 			motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	bra L93
L92:
		NOP

	.dbline 187
L93:
	.dbline 184
; 			while(done==0)
	ldd _done
	beq L92
	.dbline 189
; 			{
; 				asm("NOP");
; 			}
; 		
; 			motorp(RIGHT_MOTOR, 0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 190
; 			motorp(LEFT_MOTOR, 0);			
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 191
; 			PA_OFF();
	jsr _PA_OFF
	.dbline 192
; }
L85:
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 197
; 
; 
; void PAV_isr(void)
; {
; 	if(counter==0)
	ldd _counter
	bne L96
	.dbline 199
; 	{
; 		motorp(RIGHT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 200
; 		motorp(LEFT_MOTOR,0);
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 201
; 		done=1;
	ldd #1
	std _done
	.dbline 202
; 	}
	bra L97
L96:
	.dbline 205
; 	else
; 	{
; 		counter--;
	ldd _counter
	subd #1
	std _counter
	.dbline 206
; 	}
L97:
	.dbline 207
; 	CLEAR_FLAG(TFLG2, 0x20);
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 208
; }
L95:
	rti
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 214
; 
; void init_PA(void)
; {
; 	INTR_OFF();
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 215
; 	CLEAR_BIT(PACTL, 0x40); /* Disable PA until needed */
	ldy #0x1026
	bclr 0,y,#0x40
	.dbline 218
; 	
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 219
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
	ldy #0x1024
	bset 0,y,#32
	.dbline 221
; 
; 	PACNT=0x00;
	clr 0x1027
			cli

	.dbline 224
; 
; 	INTR_ON();
; }
L98:
	rts
;  IX -> 0,x
_TURN_AROUND::
	.dbfunc TURN_AROUND
	.dbline 229
; 
; 
; void TURN_AROUND(void)
; {
; 	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	ldd #-75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 230
; 	motorp(LEFT_MOTOR, MAX_LEFT);
	ldd #100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 231
; 	wait(TURN_AROUND_DELAY);
	ldd #800
	jsr _wait
	.dbline 232
; 	speedr = MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 233
; 	speedl = MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 234
; }
L99:
	rts
;  IX -> 0,x
_PA_ON::
			sei

	.dbfunc PA_ON
	.dbline 239
; 
; void PA_ON(void)
; {
; 	INTR_OFF();
; 	SET_BIT(PACTL, 0x40); // Enable PA
	ldy #0x1026
	bset 0,y,#64
			cli

	.dbline 241
; 	INTR_ON();
; }
L100:
	rts
;  IX -> 0,x
_PA_OFF::
			sei

	.dbfunc PA_OFF
	.dbline 246
; 
; void PA_OFF(void)
; {
; 	INTR_OFF();
; 	CLEAR_BIT(PACTL, 0x40); // Disable PA
	ldy #0x1026
	bclr 0,y,#0x40
			cli

	.dbline 248
; 	INTR_ON();
; }
L101:
	rts
;  IX -> 0,x
;           irdc -> 2,x
;            std -> 4,x
;           diff -> 6,x
;           irdl -> 8,x
;           irdr -> 10,x
_STRAIGHTEN::
	jsr __enterb
	.byte 0xc
	.dbfunc STRAIGHTEN
	.dbline 258
; 
; void STRAIGHTEN(void)
; {
; 
; 	int irdr, irdl, irdc;
; 	int diff, std;
; 	
; //	std=(RIGHT_IR + LEFT_IR) / 2;
; 
; 	std=125;
	ldd #125
	std 4,x
	.dbline 260
; 
; 	irdl=LEFT_IR;
	ldd #3
	jsr _analog
	std 8,x
	.dbline 261
; 	irdr=RIGHT_IR;
	ldd #2
	jsr _analog
	std 10,x
	.dbline 262
; 	irdc=CENTER_IR;
	ldd #7
	jsr _analog
	std 2,x
	.dbline 264
; 		
; 	if (irdr > irdl)
	ldd 10,x
	cpd 8,x
	ble L103
	.dbline 266
; 	{
; 		diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
	ldd 10,x
	subd 8,x
	xgdy
	ldd #20
	jsr __muli
	pshb ; 
	psha ; spill
	ldd #126
	subd 4,x
	xgdy
	pula ; 
	pulb ; reload
	jsr __divi
	std 6,x
	.dbline 267
; 		speedl = MAX_LEFT - diff;
	ldd #100
	subd 6,x
	std _speedl
	.dbline 268
; 	}
L103:
	.dbline 270
; 	
; 	if (irdl > irdr)
	ldd 8,x
	cpd 10,x
	ble L105
	.dbline 272
; 	{
; 		diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
	ldd 8,x
	subd 10,x
	xgdy
	ldd #20
	jsr __muli
	pshb ; 
	psha ; spill
	ldd #126
	subd 4,x
	xgdy
	pula ; 
	pulb ; reload
	jsr __divi
	std 6,x
	.dbline 273
; 		speedr = MAX_RIGHT - diff;
	ldd #75
	subd 6,x
	std _speedr
	.dbline 274
; 	}
L105:
	.dbline 276
; 			
; 	motorp(RIGHT_MOTOR, speedr);
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 277
; 	motorp(LEFT_MOTOR, speedl);
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 278
; 	wait(DELAY_TIME);
	ldd #50
	jsr _wait
	.dbline 279
; }
L102:
	xgdx
	addd #12
	xgdx
	txs
	pulx
	rts
	.area bss
_done::
	.blkb 2
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_counter::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
