	.module works.c
	.dbfile works.c
	.area text
;  IX -> 0,x
_SCI_isr::
	.dbfile C:\spinuzza\include/isrdecl.h
	.dbfunc SCI_isr
	.dbline 38
; //battery must be fully charged for it to stop
; 
; /*************************** Includes ********************************/
; #include <tjpbase.h>
; #include <stdio.h>
; /************************ End of Includes ****************************/
; 
; /*************************** Constants ********************************/
; #define AVOID_THRESHOLD 100
; #define IR_MAX 126
; #define IR_MIN 88
; #define MAX_RIGHT 75
; #define MAX_LEFT 100
; #define AMOUNT 300
; #define DELAY_TIME 25
; #define STOP 123
; #define NOWALL 90
; #define WALL 105
; #define STRAIGHT_DELAY 550
; #define TURN_DELAY 850
; #define TURN_AROUND_DELAY 800
; 
; /************************ End of Constants ****************************/
; #pragma interrupt_handler PAV_isr
; /*************************** Prototypes *********************************/
; void init_PA(void);
; void PAV_isr(void);
; void TURN_RIGHT(void);
; void TURN_LEFT(void);
; void TURN_AROUND(void);
; /************************ End of Prototypes *****************************/
; 
; int speedr, speedl;
; 
; void main(void)
; /****************************** Main ***********************************/
; {
; 	int irdr, irdl, irdc;
L2:
	rti
;  IX -> 0,x
_SPI_isr::
	.dbfunc SPI_isr
	.dbline 44
; 	int done;
; 	int diff;
; 
; 	init_analog();
; 	init_motortjp();
; 	init_clocktjp();
L3:
	rti
;  IX -> 0,x
_PAIE_isr::
	.dbfunc PAIE_isr
	.dbline 57
; 
; 	IRE_ON;
; 
; 	speedr = MAX_RIGHT;
; 	speedl = MAX_LEFT;
; 	
; 	done=0;
; 
; 	START;
; 	
; 
; 	while(1)
; 	{
L4:
	rti
;  IX -> 0,x
_TOF_isr::
	.dbfunc TOF_isr
	.dbline 63
; 		
; 		speedr=MAX_RIGHT;
; 		speedl=MAX_LEFT;
; 	
; 		irdr=RIGHT_IR;
; 		irdl=LEFT_IR;
L5:
	rti
;  IX -> 0,x
_TOC4_isr::
	.dbfunc TOC4_isr
	.dbline 75
; 		irdc=CENTER_IR;
; 
; 		if(irdr >= WALL)
; 		{
; 			diff = irdr - WALL;
; 			
; 			if(diff >= 1)
; 			{
; 			 speedl = MAX_LEFT - 25;
; 			}
; 			if(diff >= 2)
; 			{
L6:
	rti
;  IX -> 0,x
_TOC2_isr::
	.dbfunc TOC2_isr
	.dbline 81
; 			 speedl = MAX_LEFT - 40;
; 			}
; 			if(diff >= 4)
; 			{
; 			 speedl = MAX_LEFT - 75;
; 			}
L7:
	rti
;  IX -> 0,x
_TOC3_isr::
	.dbfunc TOC3_isr
	.dbline 87
; 			if(diff >= 6)
; 			{
; 			 speedl = MAX_LEFT - 90;
; 			}
; 		}
; 		
L8:
	rti
;  IX -> 0,x
_TIC3_isr::
	.dbfunc TIC3_isr
	.dbline 99
; 		else
; 		{
; 			diff = WALL - irdr;
; 			
; 			if(diff >= 1)
; 			{
; 			 speedr = MAX_RIGHT - 25;
; 			}
; 			if(diff >= 2)
; 			{
; 			 speedr = MAX_RIGHT - 35;
; 			}
L9:
	rti
;  IX -> 0,x
_TIC2_isr::
	.dbfunc TIC2_isr
	.dbline 105
; 			if(diff >= 4)
; 			{
; 			 speedr = MAX_RIGHT - 55;
; 			}
; 			if(diff >= 6)
; 			{
L10:
	rti
;  IX -> 0,x
_TIC1_isr::
	.dbfunc TIC1_isr
	.dbline 111
; 			 speedr = MAX_RIGHT - 70;
; 			}
; 		}
; 		
; 		
; 		if ((irdc >= STOP) & (irdr >= WALL) & (irdl >= WALL))
L11:
	rti
;  IX -> 0,x
_RTI_isr::
	.dbfunc RTI_isr
	.dbline 117
; 		{
; 			TURN_AROUND();
; 		}
; 		
; 		if((irdr < IR_MIN+1) & (irdc < IR_MIN+1) & (irdl < IR_MIN+1))
; 		{
L12:
	rti
;  IX -> 0,x
_IRQ_isr::
	.dbfunc IRQ_isr
	.dbline 123
; 			motorp(RIGHT_MOTOR,0);
; 			motorp(LEFT_MOTOR,0);
; 			speedr=MAX_RIGHT;
; 			speedl=MAX_LEFT;
; 			START;
; 		}			 
L13:
	rti
;  IX -> 0,x
_XIRQ_isr::
	.dbfunc XIRQ_isr
	.dbline 129
; 
; 		if(FRONT_BUMP)
; 		{
; 			speedr=-MAX_RIGHT;
; 			speedl=-MAX_LEFT;
; 			motorp(RIGHT_MOTOR, speedr);
L14:
	rti
;  IX -> 0,x
_SWI_isr::
	.dbfunc SWI_isr
	.dbline 135
; 			motorp(LEFT_MOTOR, speedl);
; 			wait(5 * DELAY_TIME);
; 			
; 		}
; 				
; 		motorp(RIGHT_MOTOR, speedr);
L15:
	rti
;  IX -> 0,x
_ILLOP_isr::
	.dbfunc ILLOP_isr
	.dbline 141
; 		motorp(LEFT_MOTOR, speedl);
; 		wait(DELAY_TIME);
; 	}
; }
; 	
; 
L16:
	rti
;  IX -> 0,x
_COP_isr::
	.dbfunc COP_isr
	.dbline 147
; void PAV_isr(void)
; {
; 	CLEAR_FLAG(TFLG2, 0x20);
; }
; 
; void init_PA(void)
L17:
	rti
;  IX -> 0,x
_CLMON_isr::
	.dbfunc CLMON_isr
	.dbline 153
; {
; 	INTR_OFF();
; 
; 	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
; 	SET_BIT(PACTL, 0x40); /*Enable PA*/
; 	
L18:
	rti
	.area data
_drew::
	.blkw 1
	.area idata
	.word _interrupt_vectors
	.area text
;  IX -> 0,x
;          ?temp -> 2,x
;          ?temp -> 4,x
;          ?temp -> 6,x
;          ?temp -> 8,x
;          ?temp -> 10,x
;          ?temp -> 12,x
;           done -> 14,x
;           irdc -> 16,x
;           irdl -> 18,x
;           diff -> 20,x
;           irdr -> 22,x
_main::
	jsr __enterb
	.byte 0x18
	.dbfile works.c
	.dbfunc main
	.dbline 42
	jsr _init_analog
	.dbline 43
	jsr _init_motortjp
	.dbline 44
	jsr _init_clocktjp
	.dbline 46
	ldab #7
	stab 0x7000
	.dbline 48
	ldd #75
	std _speedr
	.dbline 49
	ldd #100
	std _speedl
	.dbline 51
	ldd #0
	std 14,x
L20:
	.dbline 53
L21:
	ldd #0
	jsr _analog
	cpd #120
	blt L20
	jmp L24
L23:
	.dbline 59
	ldd #75
	std _speedr
	.dbline 60
	ldd #100
	std _speedl
	.dbline 62
	ldd #2
	jsr _analog
	std 22,x
	.dbline 63
	ldd #3
	jsr _analog
	std 18,x
	.dbline 64
	ldd #7
	jsr _analog
	std 16,x
	.dbline 66
	ldd 22,x
	cpd #105
	blt L26
	.dbline 68
	ldd 22,x
	subd #105
	std 20,x
	.dbline 70
	ldd 20,x
	cpd #1
	blt L28
	.dbline 72
	ldd #75
	std _speedl
	.dbline 73
L28:
	.dbline 74
	ldd 20,x
	cpd #2
	blt L30
	.dbline 76
	ldd #60
	std _speedl
	.dbline 77
L30:
	.dbline 78
	ldd 20,x
	cpd #4
	blt L32
	.dbline 80
	ldd #25
	std _speedl
	.dbline 81
L32:
	.dbline 82
	ldd 20,x
	cpd #6
	blt L27
	.dbline 84
	ldd #10
	std _speedl
	.dbline 86
	bra L27
L26:
	.dbline 90
	ldd #105
	subd 22,x
	std 20,x
	.dbline 92
	ldd 20,x
	cpd #1
	blt L36
	.dbline 94
	ldd #50
	std _speedr
	.dbline 95
L36:
	.dbline 96
	ldd 20,x
	cpd #2
	blt L38
	.dbline 98
	ldd #40
	std _speedr
	.dbline 99
L38:
	.dbline 100
	ldd 20,x
	cpd #4
	blt L40
	.dbline 102
	ldd #20
	std _speedr
	.dbline 103
L40:
	.dbline 104
	ldd 20,x
	cpd #6
	blt L42
	.dbline 106
	ldd #5
	std _speedr
	.dbline 107
L42:
	.dbline 108
L27:
	.dbline 111
	ldd 16,x
	cpd #123
	blt L49
	ldd #1
	std 12,x
	bra L50
L49:
	ldd #0
	std 12,x
L50:
	ldd 22,x
	cpd #105
	blt L51
	ldd #1
	std 10,x
	bra L52
L51:
	ldd #0
	std 10,x
L52:
	ldd 18,x
	cpd #105
	blt L53
	ldd #1
	std 8,x
	bra L54
L53:
	ldd #0
	std 8,x
L54:
	ldd 12,x
	anda 10,x
	andb 11,x
	anda 8,x
	andb 9,x
	cpd #0
	beq L44
	.dbline 113
	jsr _TURN_AROUND
	.dbline 114
L44:
	.dbline 116
	ldd 22,x
	cpd #89
	bge L60
	ldd #1
	std 6,x
	bra L61
L60:
	ldd #0
	std 6,x
L61:
	ldd 16,x
	cpd #89
	bge L62
	ldd #1
	std 4,x
	bra L63
L62:
	ldd #0
	std 4,x
L63:
	ldd 18,x
	cpd #89
	bge L64
	ldd #1
	std 2,x
	bra L65
L64:
	ldd #0
	std 2,x
L65:
	ldd 6,x
	anda 4,x
	andb 5,x
	anda 2,x
	andb 3,x
	cpd #0
	beq L55
	.dbline 118
	ldd #0
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 119
	ldd #0
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 120
	ldd #75
	std _speedr
	.dbline 121
	ldd #100
	std _speedl
L66:
	.dbline 122
L67:
	ldd #0
	jsr _analog
	cpd #120
	blt L66
	.dbline 123
L55:
	.dbline 125
	ldd #0
	jsr _analog
	cpd #38
	ble L69
	ldd #0
	jsr _analog
	cpd #120
	bge L69
	.dbline 127
	ldd #-75
	std _speedr
	.dbline 128
	ldd #-100
	std _speedl
	.dbline 129
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 130
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 131
	ldd #125
	jsr _wait
	.dbline 133
L69:
	.dbline 135
	ldd _speedr
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 136
	ldd _speedl
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 137
	ldd #25
	jsr _wait
	.dbline 138
L24:
	.dbline 56
	jmp L23
L19:
	xgdx
	addd #24
	xgdx
	txs
	pulx
	rts
;  IX -> 0,x
_PAV_isr::
	.dbfunc PAV_isr
	.dbline 144
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 145
L71:
	rti
;  IX -> 0,x
_init_PA::
			sei

	.dbfunc init_PA
	.dbline 151
	ldy #0x1026
	bclr 0,y,#0xb0
	.dbline 152
	ldy #0x1026
	bset 0,y,#64
	.dbline 155
; 
; 	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	ldy #0x1025
	bclr 0,y,#0xdf
	.dbline 156
; 	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */
	ldy #0x1024
	bset 0,y,#32
	.dbline 158
; 
; 	PACNT=0x00;
	clr 0x1027
			cli

	.dbline 161
; 
; 	INTR_ON();
; }
L72:
	rts
;  IX -> 0,x
_TURN_AROUND::
	.dbfunc TURN_AROUND
	.dbline 166
; 
; 
; void TURN_AROUND(void)
; {
; 	motorp(RIGHT_MOTOR, MAX_RIGHT);
	ldd #75
	pshb
	psha
	ldd #1
	jsr _motorp
	puly
	.dbline 167
; 	motorp(LEFT_MOTOR, -MAX_LEFT);
	ldd #-100
	pshb
	psha
	ldd #0
	jsr _motorp
	puly
	.dbline 168
; 	wait(TURN_AROUND_DELAY);
	ldd #800
	jsr _wait
	.dbline 169
; 	speedr = MAX_RIGHT;
	ldd #75
	std _speedr
	.dbline 170
; 	speedl = MAX_LEFT;
	ldd #100
	std _speedl
	.dbline 172
; 
; }
L73:
	rts
	.area bss
_speedl::
	.blkb 2
_speedr::
	.blkb 2
_timertjp::
	.blkb 2
_days::
	.blkb 2
_hours::
	.blkb 2
_minutes::
	.blkb 2
_seconds::
	.blkb 2
_msec::
	.blkb 2
