/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define AVOID_THRESHOLD 100
#define IR_MAX 126
#define IR_MIN 88
#define MAX_RIGHT 75
#define MAX_LEFT 100
#define AMOUNT 40
#define DELAY_TIME 50
#define STOP 123
#define NOWALL 95
/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
void init_PA(void);
void PAV_isr(void);
/************************ End of Prototypes *****************************/

int counter;
int speedr;
int speedl;

void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int std;
	int speedr, speedl;
	int diff;

	init_analog();
	init_motortjp();
	init_clocktjp();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;

	START;
	
//	stdr=RIGHT_IR;
//	stdl=LEFT_IR;

//	std = (RIGHT_IR + LEFT_IR) / 2;

	std = 110;
		
	while(1)
	{
		irdl=LEFT_IR;
		irdr=RIGHT_IR;
		irdc=CENTER_IR;
		
		if (irdr > irdl)
		{
			diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
			speedl = MAX_LEFT - diff;
		}
		
		if (irdl > irdr)
		{
			diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
			speedr = MAX_RIGHT - diff;
		}
			
		if ((irdc > STOP) & (irdr > NOWALL) & (irdl > NOWALL))
		{
			speedr=0;
			speedl=0;
		}

		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(10 * DELAY_TIME);
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}
	

void PAV_isr(void)
{
	counter=counter+1;
	if (counter==10)
	{
	 speedr=0;
	 speedl=0;
	}
	CLEAR_FLAG(TFLG2, 0x20);
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}