//battery must be fully charged for it to stop

/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define PAV_TURN	0x40
#define PAV_STRAIGHT 0x80
#define AVOID_THRESHOLD 100
#define IR_MAX 126
#define IR_MIN 88
#define MAX_RIGHT 75
#define MAX_LEFT 100
#define AMOUNT 300
#define DELAY_TIME 25
#define STOP 123
#define NOWALL 90
#define WALL 105
#define STRAIGHT_DELAY 550
#define TURN_DELAY 850
#define TURN_AROUND_DELAY 800
#define NOWALL2 96
#define WALL2 100

/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
void init_PA(void);
void PAV_isr(void);
void TURN_RIGHT(void);
void TURN_LEFT(void);
void TURN_AROUND(void);
void first(void);
void second(void);
void third(void);
void PA_ON(void);
void PA_OFF(void);
void STRAIGHTEN(void);
/************************ End of Prototypes *****************************/

int speedr, speedl;
int counter;
int done;
int repeat;

void main(void)
{
	printf("\n");
	while(1)
	{
		repeat=0;
		while(repeat==0)
		{
			printf("One\n");
			first();

			while(BUMPER < 20)
			{
				printf("One or Two\n");
				if(FRONT_BUMP)
				{
					repeat=0;
				}
				else if(BACK_BUMP)
				{
					repeat=1;
				}
			}
			wait(5000);
			START;
		}
		repeat=0;
		while(repeat==0)
		{
			printf("Two\n");
			second();
			
			while(BUMPER < 20)
			{
				if(FRONT_BUMP)
				{
					repeat=0;
				}
				else if(BACK_BUMP)
				{
					repeat=1;
				}
			}
			wait(5000);
			START;
		}
		repeat=0;
		while(repeat==0)
		{
			printf("Three\n");
			third();
		
			while(BUMPER < 20)
			{
				if(FRONT_BUMP)
				{
					repeat=0;
				}
				else if(BACK_BUMP)
				{
					repeat=1;
				}
			}
			wait(5000);
			START;
		}
	}
}

void first(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int diff;

	init_analog();
	init_motortjp();
	init_clocktjp();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
	
	done=0;

	START;
	
	while(done == 0)
	{
		
		speedr=MAX_RIGHT;
		speedl=MAX_LEFT;
	
		irdr=RIGHT_IR;
		irdl=LEFT_IR;
		irdc=CENTER_IR;

		if(irdr >= WALL)
		{
			diff = irdr - WALL;
			
			if(diff >= 1)
			{
			 speedl = MAX_LEFT - 25;
			}
			if(diff >= 2)
			{
			 speedl = MAX_LEFT - 40;
			}
			if(diff >= 4)
			{
			 speedl = MAX_LEFT - 75;
			}
			if(diff >= 6)
			{
			 speedl = MAX_LEFT - 85;
			}
		}
		
		else
		{
			diff = WALL - irdr;
			
			if(diff >= 1)
			{
			 speedr = MAX_RIGHT - 25;
			}
			if(diff >= 2)
			{
			 speedr = MAX_RIGHT - 35;
			}
			if(diff >= 4)
			{
			 speedr = MAX_RIGHT - 55;
			}
			if(diff >= 6)
			{
			 speedr = MAX_RIGHT - 65;
			}
		}
		
		
		if ((irdc >= STOP) & (irdr >= WALL) & (irdl >= WALL))
		{
			TURN_AROUND();
		}
		
		if((irdr < IR_MIN + 1) & (irdc < IR_MIN + 1) & (irdl < IR_MIN + 1))
		{
			motorp(RIGHT_MOTOR,0);
			motorp(LEFT_MOTOR,0);
			speedr=0;
			speedl=0;
			done=1;
		}
				 
		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(5 * DELAY_TIME);
			
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}
	

void TURN_AROUND(void)
{
	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_AROUND_DELAY);
	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;

}

void second(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int std;
	int diff;
		
	init_analog();
	init_motortjp();
	init_clocktjp();
	init_PA();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
	
	done=0;

	START;
	
	std = (RIGHT_IR + LEFT_IR) / 2;

	while(done==0)
	{
		irdl=LEFT_IR;
		irdr=RIGHT_IR;
		irdc=CENTER_IR;

		if ((irdr <= NOWALL2) & ((irdc >= WALL2) | (irdl >= WALL2)))
		{
			TURN_RIGHT();
		}
		else if ((irdl <= NOWALL2) & ((irdc >= WALL2) | (irdr >= WALL2)))
		{
			TURN_LEFT();
		}
		else if ((irdc >= STOP) & (irdr >= WALL2) & (irdl >= WALL2))
		{
			TURN_AROUND();
		}
		
		if((irdr < IR_MIN + 1) & (irdc < IR_MIN + 1) & (irdl < IR_MIN + 1))
		{
			motorp(RIGHT_MOTOR,0);
			motorp(LEFT_MOTOR,0);
			speedr=0;
			speedl=0;
			done=1;
		}			 

		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(5 * DELAY_TIME);
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}

void TURN_RIGHT(void)
{

			PA_ON();
			counter=1;
			PACNT=PAV_STRAIGHT;
			done=0;
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}
			counter=1;
			PACNT = PAV_TURN;			
			done=0;
			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}

			counter=1;
//			PACNT = PAV_STRAIGHT;
			PACNT = 0xFF;
			done=0;			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}

			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, 0);
			PA_OFF();
}



void TURN_LEFT(void)
{
			PA_ON();
			counter=1;
			PACNT=PAV_STRAIGHT;
			done=0;
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}

			counter=1;
			PACNT = PAV_TURN;			
			done=0;
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, 0);
			while(done==0)
			{
				asm("NOP");
			}
			
			counter=1;
//			PACNT = PAV_STRAIGHT;
			PACNT = 0xFF;
			done=0;			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}
		
			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, 0);
			PA_OFF();
}


void PAV_isr(void)
{
	if(counter==0)
	{
		motorp(RIGHT_MOTOR,0);
		motorp(LEFT_MOTOR,0);
		done=1;
	}
	else
	{
		counter--;
	}
	CLEAR_FLAG(TFLG2, 0x20);
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	CLEAR_BIT(PACTL, 0x40); /*Disable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}

void PA_ON(void)
{
	INTR_OFF();
	SET_BIT(PACTL, 0x40); // Enable PA
	INTR_ON();
}

void PA_OFF(void)
{
	INTR_OFF();
	CLEAR_BIT(PACTL, 0x40); // Disable PA
	INTR_ON();
}

void third(void)
{
	int irdr, irdl, irdc;
	int std;
	int diff;
	int done;
	
	
	init_analog();
	init_motortjp();
	init_clocktjp();
	init_PA();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
	
	done=0;	

	START;
	
	while(done==0)
	{

		std = (RIGHT_IR + LEFT_IR) / 2;

		irdl=LEFT_IR;
		irdr=RIGHT_IR;
		irdc=CENTER_IR;

		if ((irdr <= NOWALL2) & ((irdc >= STOP) | (irdl >= WALL2)))
		{
			TURN_RIGHT();
			STRAIGHTEN();
			STRAIGHTEN();
			STRAIGHTEN();
			STRAIGHTEN();
		}
		else if ((irdl <= NOWALL2) & ((irdc >= STOP) | (irdr >= WALL2)))
		{
			TURN_LEFT();
			STRAIGHTEN();
			STRAIGHTEN();
			STRAIGHTEN();
			STRAIGHTEN();
		}
		else if ((irdc >= STOP) & ((irdr >= WALL2) & (irdl >= WALL2)))
		{
			TURN_AROUND();
			STRAIGHTEN();
			STRAIGHTEN();
			STRAIGHTEN();
			STRAIGHTEN();
		}
	
		if((irdr < IR_MIN + 1) & (irdc < IR_MIN + 1) & (irdl < IR_MIN + 1))
		{
			motorp(RIGHT_MOTOR,0);
			motorp(LEFT_MOTOR,0);
			speedr=0;
			speedl=0;
			done=1;
		}			 

		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(5 * DELAY_TIME);
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}
void STRAIGHTEN(void)
{

	int irdr, irdl, irdc;
	int diff, std;
	
//	std=(RIGHT_IR + LEFT_IR) / 2;

	std=125;

	irdl=LEFT_IR;
	irdr=RIGHT_IR;
	irdc=CENTER_IR;
		
	if (irdr > irdl)
	{
		diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
		speedl = MAX_LEFT - diff;
	}
	
	if (irdl > irdr)
	{
		diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
		speedr = MAX_RIGHT - diff;
	}
			
	motorp(RIGHT_MOTOR, speedr);
	motorp(LEFT_MOTOR, speedl);
	wait(DELAY_TIME);
}
