/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
#include <algconst.h>
#include <algproc.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define TABLE_LENGTH 400
#define WALL_STOP 95
#define DIFF 4

/************************ End of Constants ****************************/
/*************************** Prototypes *********************************/
/************************ End of Prototypes *****************************/

int speedr, speedl;

void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int std, diff;
	int irdt;

	init_analog();
	init_motortjp();
	init_clocktjp();

	IRE_ON;

	START;
	
	std=110;
		
	while(1)
	{
		
		speedr=MAX_RIGHT;
		speedl=MAX_LEFT;
	
		irdr=RIGHT_IR;
		irdl=LEFT_IR;
		irdc=CENTER_IR;

//		if ((irdr > irdl) & ((irdr - irdl) < 10))
		if (irdr > irdl)
		{
			diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
			speedl = MAX_LEFT - diff;
		}
		
//		if ((irdl > irdr) & ((irdl - irdr) < 10))
		if (irdl > irdr)
		{
			diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
			speedr = MAX_RIGHT - diff;
		}

		if(irdr < 93)
		{
			irdt = irdr;
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(STRAIGHT_DELAY);

			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(CENTER_IR > irdt + DIFF)
			{
				asm("NOP");
			}

			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(STRAIGHT_DELAY/2);
		}
		else if((irdl < 93) & (irdr > 100) & (irdc > 100))
//		else if(irdl < 93)
		{
			irdt = irdl;
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(STRAIGHT_DELAY);

			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, 0);
			
			while(CENTER_IR > irdt + DIFF)
			{
				asm("NOP");
			}
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(STRAIGHT_DELAY/2);
			
		}
		 
		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(4 * DELAY_TIME);
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}