//battery must be fully charged for it to stop

/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define AVOID_THRESHOLD 100
#define IR_MAX 126
#define IR_MIN 88
#define MAX_RIGHT 75
#define MAX_LEFT 100
#define AMOUNT 300
#define DELAY_TIME 25
#define STOP 123
#define NOWALL 90
#define WALL 105
#define STRAIGHT_DELAY 550
#define TURN_DELAY 850
#define TURN_AROUND_DELAY 800
#define ZERO 0x7D
#define ONE 0x30
#define TWO 0x6E
#define THREE 0x7A
#define FOUR 0x33
#define FIVE 0x5B
#define SIX 0x1F
#define SEVEN 0x70
#define EIGHT 0x7F
#define NINE 0x73
#define DISPLAY *(unsigned char *)(0x5000)


/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
void init_PA(void);
void PAV_isr(void);
void TURN_RIGHT(void);
void TURN_LEFT(void);
void TURN_AROUND(void);
void update_LED(void);
/************************ End of Prototypes *****************************/

int speedr, speedl;
int smallcounter, bigcounter;
int NUMBERS[10]={0x7D,0X30,0X6E,0X7A,0X33,0X5B,0X1F,0X70,0X7F,0X73};

/*
NUMBERS[0]=0x7D;
NUMBERS[1]=0x30;
NUMBERS[2]=0x6E;
NUMBERS[3]=0x7A;
NUMBERS[4]=0x33;
NUMBERS[5]=0x5B;
NUMBERS[6]=0x1F;
NUMBERS[7]=0x70;
NUMBERS[8]=0x7F;
NUMBERS[9]=0x73;
*/

/*
#define ZERO 0x7D
#define ONE 0x30
#define TWO 0x6E
#define THREE 0x7A
#define FOUR 0x33
#define FIVE 0x5B
#define SIX 0x1F
#define SEVEN 0x70
#define EIGHT 0x7F
#define NINE 0x73
*/


void main(void)
/****************************** Main ***********************************/
{

	init_analog();
	init_motortjp();
	init_clocktjp();
	init_PA();

	DISPLAY=NUMBERS[0];

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;

	while(1)
	{
	motorp(RIGHT_MOTOR, speedr);
	motorp(LEFT_MOTOR, speedl);
	wait(1000);
	}

}

void PAV_isr(void)
{
	CLEAR_FLAG(TFLG2, 0x20);
	smallcounter++;
	if(smallcounter==5)
	{
		smallcounter=0;
		bigcounter++;
		if(bigcounter == 9)
		{
			speedr=0;
			speedl=0;
		}
		DISPLAY=NUMBERS[bigcounter];
	}
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}


void TURN_AROUND(void)
{
	motorp(RIGHT_MOTOR, MAX_RIGHT);
	motorp(LEFT_MOTOR, -MAX_LEFT);
	wait(TURN_AROUND_DELAY);
	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
}
