/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define AVOID_THRESHOLD 100
#define IR_MAX 126
#define IR_MIN 88
#define MAX_RIGHT 75
#define MAX_LEFT 100
#define AMOUNT 3
#define DELAY_TIME 25
#define TABLE_LENGTH 30
/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
int avg(int list[]);
void init_PA(void);
void PAV_isr(void);
/************************ End of Prototypes *****************************/

int counter;
int speedr;
int speedl;

void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc, stdr, stdl;
	int right[TABLE_LENGTH], left[TABLE_LENGTH];
	int counter;
	int upr, upl, downr, downl;
	int diff;
	int i;

	init_analog();
	init_motortjp();
	init_clocktjp();

	counter=0;

	IRE_ON;

	for(i=0;i<30;i++)
	{
	 right[i]=RIGHT_IR;
	 left[i]=LEFT_IR;
	}

	START;
	
	while(1)
	{
		speedr=MAX_RIGHT;
		speedl=MAX_LEFT;
	
		irdr=RIGHT_IR;
		irdl=LEFT_IR;
		irdc=CENTER_IR;

		right[counter]=irdr;
		left[counter]=irdl;
		
		if(counter < TABLE_LENGTH)
		{
			counter++;
		}
		
		if(counter== TABLE_LENGTH)
		{
			counter=0;
		}
		
		stdr = avg(right);
		stdl = avg(left);

		upr = IR_MAX - stdr;
		downr = stdr - IR_MIN;
	
		upl = IR_MAX - stdl;
		downl = stdl - IR_MIN;

		if (irdr > stdr)
		{
			diff = (((irdr - stdr) * (irdr - stdr) * AMOUNT)) / (upr);
			speedl = MAX_LEFT - diff;
		}
		
		else
		{
			diff = (((stdr - irdr) * (irdr - stdr) * AMOUNT)) / (downr);
			speedr = MAX_RIGHT - diff;
		}		

		if ((irdc > 120) & (irdl > 105) & (irdr > 105))
		{
			speedr=0;
			speedl=0;
		}
		
		if(FRONT_BUMP)
		{
			motorp(RIGHT_MOTOR,0);
			motorp(LEFT_MOTOR,0);
			START;
			speedr=0;
			speedl=0;
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}
	

void PAV_isr(void)
{
	counter=counter+1;
	if (counter==10)
	{
	 speedr=0;
	 speedl=0;
	}
	CLEAR_FLAG(TFLG2, 0x20);
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}

int avg(int list[])
{
 int i;
 int sum;
 sum=0;
 for(i=0;i<30;i++)
 {
  sum = sum + list[i];
 }
 return (sum/TABLE_LENGTH);
}