/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define AVOID_THRESHOLD 100
#define IR_MAX 126
#define IR_MIN 88
#define MAX_RIGHT 75
#define MAX_LEFT 100
#define AMOUNT 40
#define DELAY_TIME 25
#define STOP 123
#define NOWALL 95
#define TURN 34
#define TABLE_LENGTH 200
/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
void init_PA(void);
void PAV_isr(void);
void TURN_RIGHT(void);
void TURN_LEFT(void);
void TURN_AROUND(void);
/************************ End of Prototypes *****************************/

int counter;
int speedr;
int speedl;

void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int std;
	int speedr, speedl;
	int diff, lastdiff, change;

	int right[TABLE_LENGTH];
	int left[TABLE_LENGTH];
	int center[TABLE_LENGTH];
	int counter, maxcounter;

	init_analog();
	init_motortjp();
	init_clocktjp();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
	
	counter=0;
	
	START;
	
	while(1)
	{
		irdr=RIGHT_IR;
		irdl=LEFT_IR;
		irdc=CENTER_IR;

		left[counter]=irdl;
		center[counter]=irdc;
		right[counter]=irdr;
		
		counter=counter+1;
			
		if ((counter == TABLE_LENGTH) | (irdc > 122))
		{
			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, 0);
			maxcounter=counter;
			counter=0;

			while(1)
			{
				START;
				while(counter<maxcounter)
				{
					printf("Table entry - %d %d %d\n",left[counter], center[counter], right[counter]);
					counter=counter+1;
				}
				printf("Number of entries: %d\n", counter);
			}
		}

		if (irdr > irdl)
		{
			diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
			speedl = MAX_LEFT - diff;
		}
		
		if (irdl > irdr)
		{
			diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
			speedr = MAX_RIGHT - diff;
		}
		
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(50);
	}
	
	

}
	

void PAV_isr(void)
{
	counter=counter+1;
	if (counter==10)
	{
	 speedr=0;
	 speedl=0;
	}
	CLEAR_FLAG(TFLG2, 0x20);
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}

void TURN_RIGHT(void)
{
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN*DELAY_TIME);

			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN * DELAY_TIME);
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(2 * TURN * DELAY_TIME);

			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			
		}

void TURN_LEFT(void)
{
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN*DELAY_TIME);

			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, 0);
			wait(TURN * DELAY_TIME);
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(2 * TURN * DELAY_TIME);

			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			
		}

void TURN_AROUND(void)
{
	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait((TURN - 4) * DELAY_TIME);
	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
}