/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
#include <algconst.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define TABLE_LENGTH 400

/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
void init_PA(void);
void PAV_isr(void);
void TURN_RIGHT(void);
void TURN_LEFT(void);
void TURN_AROUND(void);
/************************ End of Prototypes *****************************/

int counter;
int speedr;
int speedl;

int right[TABLE_LENGTH], left[TABLE_LENGTH], center[TABLE_LENGTH];
	
int counter, maxcounter;


void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int oldr, oldl;
	int newr, newl;
	int std;
	int diff;
	
	
	init_analog();
	init_motortjp();
	init_clocktjp();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
	
	counter=0;

	START;
	
	oldr=RIGHT_IR;
	oldl=LEFT_IR;
	
	
	std = (RIGHT_IR + LEFT_IR) / 2;

	while(1)
	{
		newl=LEFT_IR;
		newr=RIGHT_IR;
		irdc=CENTER_IR;
		
		irdl = (newl + oldl) / 2;
		irdr = (newr + oldr) / 2;
						
		right[counter]=irdr;
		center[counter]=irdc;
		left[counter]=irdl;
		counter=counter+1;
		
		if(counter>=TABLE_LENGTH)
		{
		 motorp(RIGHT_MOTOR,0);
		 motorp(LEFT_MOTOR,0);
		 while(1)
		 {
		  counter=0;
		  START;
		  printf("Starting\n");
		  while(counter<maxcounter)
		  {
		  	printf("Entry - %d %d %d\n",left[counter],center[counter],right[counter]);
			counter=counter+1;
		  }
		  printf("Total number of entries: %d\n",counter);
		 }
		}
		maxcounter=counter;
		
		if (irdr > irdl)
		{
			diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
			speedl = MAX_LEFT - diff;
		}
		
		if (irdl > irdr)
		{
			diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
			speedr = MAX_RIGHT - diff;
		}
		

		if ((irdr <= NOWALL) & ((irdc >= NOWALL) | (irdl >= NOWALL)))
		{
			TURN_RIGHT();
			std = (RIGHT_IR + LEFT_IR) / 2;

		}
		else if ((irdl <= NOWALL) & ((irdc >= NOWALL) | (irdr >= NOWALL)))
		{
			TURN_LEFT();
			std = (RIGHT_IR + LEFT_IR) / 2;
		}
			
		else if ((irdc >= STOP) & (irdr >= NOWALL) & (irdl >= NOWALL))
		{
			TURN_AROUND();
		}
		
		if((irdr < NOWALL) & (irdc < NOWALL) & (irdl < NOWALL))
		{
			motorp(RIGHT_MOTOR,0);
			motorp(LEFT_MOTOR,0);
			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			START;
		}			 

		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(10 * DELAY_TIME);
			counter=TABLE_LENGTH-1;
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
		
		oldl = newl;
		oldr = newr;
	}
}
	

void PAV_isr(void)
{
	CLEAR_FLAG(TFLG2, 0x20);
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}

void TURN_RIGHT(void)
{
	motorp(RIGHT_MOTOR, MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_DELAY/2);

	motorp(RIGHT_MOTOR, 0);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_DELAY);
		
	motorp(RIGHT_MOTOR, MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_DELAY/2);

	speedr=MAX_RIGHT;
	speedl=MAX_LEFT;

	left[counter]=0;
	center[counter]=0;
	right[counter]=IR_MAX;
			
	counter=counter+1;
	maxcounter=counter;
			
}

void TURN_LEFT(void)
{
	motorp(RIGHT_MOTOR, MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_DELAY/2);

	motorp(RIGHT_MOTOR, MAX_RIGHT);
	motorp(LEFT_MOTOR, 0);
	wait(TURN_DELAY);
			
	motorp(RIGHT_MOTOR, MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_DELAY/2);

	speedr=MAX_RIGHT;
	speedl=MAX_LEFT;

	left[counter]=IR_MAX;
	center[counter]=0;
	right[counter]=0;
			
	counter=counter+1;
	maxcounter=counter;
			
		}

void TURN_AROUND(void)
{
	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_AROUND_DELAY);
	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;

	left[counter]=0;
	center[counter]=IR_MAX;
	right[counter]=0;
			
	counter=counter+1;
	maxcounter=counter;

}