/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
#include <algconst.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define TABLE_LENGTH 400

/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
void init_PA(void);
void PAV_isr(void);
void TURN_RIGHT(void);
void TURN_LEFT(void);
void TURN_AROUND(void);
/************************ End of Prototypes *****************************/

int counter;
int speedr;
int speedl;

int right[TABLE_LENGTH], left[TABLE_LENGTH], center[TABLE_LENGTH];
	
int counter, maxcounter, done;


void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int std;
	int diff;
	
	
	init_analog();
	init_motortjp();
	init_clocktjp();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
	
	counter=0;

	START;
	
	std = (RIGHT_IR + LEFT_IR) / 2;

	while(1)
	{
		irdl=LEFT_IR;
		irdr=RIGHT_IR;
		irdc=CENTER_IR;
		
		right[counter]=irdr;
		center[counter]=irdc;
		left[counter]=irdl;
		counter=counter+1;
		
		if(counter>=TABLE_LENGTH)
		{
		 motorp(RIGHT_MOTOR,0);
		 motorp(LEFT_MOTOR,0);
		 while(1)
		 {
		  counter=0;
		  START;
		  printf("Starting\n");
		  while(counter<maxcounter)
		  {
		  	printf("Entry - %d %d %d\n",left[counter],center[counter],right[counter]);
			counter=counter+1;
		  }
		  printf("Total number of entries: %d\n",counter);
		 }
		}
		maxcounter=counter;
		
/*		if (irdr > irdl)
		{
			diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
			speedl = MAX_LEFT - diff;
		}
		
		if (irdl > irdr)
		{
			diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
			speedr = MAX_RIGHT - diff;
		}
*/		

		if ((irdr <= NOWALL) & ((irdc >= WALL) | (irdl >= WALL)))
		{
			TURN_RIGHT();
//			std = (RIGHT_IR + LEFT_IR) / 2;

		}
		else if ((irdl <= NOWALL) & ((irdc >= WALL) | (irdr >= WALL)))
		{
			TURN_LEFT();
//			std = (RIGHT_IR + LEFT_IR) / 2;
		}
			
		else if ((irdc >= STOP) & (irdr >= WALL) & (irdl >= WALL))
		{
			TURN_AROUND();
		}
		
		if((irdr < IR_MIN+1) & (irdc < IR_MIN+1) & (irdl < IR_MIN+1))
		{
			motorp(RIGHT_MOTOR,0);
			motorp(LEFT_MOTOR,0);
			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			START;
		}			 

		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(5 * DELAY_TIME);
			counter=TABLE_LENGTH-1;
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}
	

void TURN_RIGHT(void)
{
			counter=1;
			PACNT=0x80;
			done=0;
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}
			counter=1;
			PACNT = 0x40;			
			done=0;
			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}

			counter=1;
			PACNT = 0x80;
			done=0;			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}

			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, 0);			
}



void TURN_LEFT(void)
{
			counter=1;
			PACNT=0x80;
			done=0;
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}

			counter=1;
			PACNT = 0x40;			
			done=0;
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, 0);
			while(done==0)
			{
				asm("NOP");
			}
			
			counter=1;
			PACNT = 0x80;
			done=0;			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}
		
			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, 0);			
}


void PAV_isr(void)
{
	if(counter==0)
	{
		motorp(RIGHT_MOTOR,0);
		motorp(LEFT_MOTOR,0);
		done=1;
	}
	else
	{
		counter--;
	}
	CLEAR_FLAG(TFLG2, 0x20);
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}


void TURN_AROUND(void)
{
	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_AROUND_DELAY);
	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;

	left[counter]=0;
	center[counter]=IR_MAX;
	right[counter]=0;
			
	counter=counter+1;
	maxcounter=counter;
}