/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
#include <alg.h>
/************************ End of Includes ****************************/


void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int std, diff;
	
	init_analog();
	init_motortjp();
	init_clocktjp();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
	
	START;
	
	std = (RIGHT_IR + LEFT_IR) / 2;
		
	while(1)
	{
		irdl=LEFT_IR;
		irdr=RIGHT_IR;
		irdc=CENTER_IR;
		
		if (irdr > irdl)
		{
			diff = ((irdr - irdl) * AMOUNT) / (IR_MAX - std);
			speedl = MAX_LEFT - diff;
		}
		
		if (irdl > irdr)
		{
			diff = ((irdl - irdr) * AMOUNT) / (IR_MAX - std);
			speedr = MAX_RIGHT - diff;
		}
		

		if ((irdr <= NOWALL) & ((irdc >= NOWALL) | (irdl >= NOWALL)))
		{
			TURN_RIGHT();
		}
		else if ((irdl <= NOWALL) & ((irdc >= NOWALL) | (irdr >= NOWALL)))
		{
			TURN_LEFT();
		}
			
		else if ((irdc >= STOP) & (irdr >= NOWALL) & (irdl >= NOWALL))
		{
			TURN_AROUND();
		}
		
		if((irdr < NOWALL) & (irdc < NOWALL) & (irdl < NOWALL))
		{
			motorp(RIGHT_MOTOR,0);
			motorp(LEFT_MOTOR,0);
			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			START;
		}			 

		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(10 * DELAY_TIME);
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}
