/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define AVOID_THRESHOLD 100
#define IR_MAX 126
#define IR_MIN 88
#define MAX_RIGHT 75
#define MAX_LEFT 100
#define AMOUNT 90
#define DELAY_TIME 25
/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
void init_PA(void);
void PAV_isr(void);
/************************ End of Prototypes *****************************/

int counter;
int speedr;
int speedl;

void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irds, stdr, stdl;
	int upr, upl, downr, downl;
	int diff;

	init_analog();
	init_motortjp();
	init_clocktjp();

	START;

	IRE_ON;
	
//	stdr=RIGHT_IR;
//	stdl=LEFT_IR;

	stdr=112;
	stdl=112;
	
	upr = IR_MAX - stdr;
	downr = stdr - IR_MIN;
	
	upl = IR_MAX - stdl;
	downl = stdl - IR_MIN;
	
	
	
	while(1)
	{
		
		speedr=MAX_RIGHT;
		speedl=MAX_LEFT;
	
		irdr=RIGHT_IR;
		irdl=LEFT_IR;
		irds=CENTER_IR;
		
		if (irdr > stdr)
		{
			diff = ((irdr-stdr) * AMOUNT) / upr;
			speedl=MAX_LEFT-diff;
		}
		
		else
		{
			diff = ((stdr - irdr) * AMOUNT) / downr;
			speedr=MAX_RIGHT - diff;
		}		

		if ((irdr < IR_MIN + 3) & (irdl < IR_MIN + 3) & (irds < IR_MIN + 3))
		{
			speedr=0;
			speedl=0;
		}
		
		if(FRONT_BUMP)
		{
			speedr=-MAX_RIGHT;
			speedl=-MAX_LEFT;
			motorp(RIGHT_MOTOR, speedr);
			motorp(LEFT_MOTOR, speedl);
			wait(10 * DELAY_TIME);
		}
				
		motorp(RIGHT_MOTOR, speedr);
		motorp(LEFT_MOTOR, speedl);
		wait(DELAY_TIME);
	}
}
	

void PAV_isr(void)
{
	counter=counter+1;
	if (counter==10)
	{
	 speedr=0;
	 speedl=0;
	}
	CLEAR_FLAG(TFLG2, 0x20);
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}