/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/

/*************************** Constants ********************************/
#define AVOID_THRESHOLD 100
#define IR_MAX 126
#define IR_MIN 88
#define MAX_RIGHT 75
#define MAX_LEFT 100
#define AMOUNT 40
#define DELAY_TIME 25
#define STOP 123
#define NOWALL 92
#define TURN_DELAY 900
#define TURN_AROUND_DELAY 800
/************************ End of Constants ****************************/
#pragma interrupt_handler PAV_isr
/*************************** Prototypes *********************************/
void init_PA(void);
void PAV_isr(void);
void TURN_RIGHT(void);
void TURN_LEFT(void);
void TURN_AROUND(void);
/************************ End of Prototypes *****************************/

int counter;
int speedr;
int speedl;

void main(void)
/****************************** Main ***********************************/
{
	int irdr, irdl, irdc;
	int std;
	int speedr, speedl;
	int diff, lastdiff, change;

	init_analog();
	init_motortjp();
	init_clocktjp();

	IRE_ON;

	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
	
	lastdiff=0;

	START;
	
//	stdr=RIGHT_IR;
//	stdl=LEFT_IR;

	std = (RIGHT_IR + LEFT_IR) / 2;

	while(1)
	{
		START;

		TURN_RIGHT();
		motorp(RIGHT_MOTOR,0);
		motorp(LEFT_MOTOR,0);

		START;

		TURN_LEFT();
		motorp(RIGHT_MOTOR,0);
		motorp(LEFT_MOTOR,0);

		START;

		TURN_AROUND();
		motorp(RIGHT_MOTOR,0);
		motorp(LEFT_MOTOR,0);
	}
}
	

void PAV_isr(void)
{
	counter=counter+1;
	if (counter==10)
	{
	 speedr=0;
	 speedl=0;
	}
	CLEAR_FLAG(TFLG2, 0x20);
}

void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}

void TURN_RIGHT(void)
{
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN_DELAY);

			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN_DELAY);
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN_DELAY);

			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			
		}

void TURN_LEFT(void)
{
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN_DELAY);

			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, 0);
			wait(TURN_DELAY);
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			wait(TURN_DELAY);

			speedr=MAX_RIGHT;
			speedl=MAX_LEFT;
			
		}

void TURN_AROUND(void)
{
	motorp(RIGHT_MOTOR, -MAX_RIGHT);
	motorp(LEFT_MOTOR, MAX_LEFT);
	wait(TURN_AROUND_DELAY);
	speedr = MAX_RIGHT;
	speedl = MAX_LEFT;
}