/************************************************************************
 * 			MEKATRONIX Copyright 1998 		        *
 * Title        clocktjp.h                                               *
 * Programmer   Keith L. Doty                                           *
 * Date         Sept 04, 1998                                          *
 * Version      1                                                       *
 *                                                                      *
 * Description								*
 *	This header file refers to all routines and interrupt drivers   *
 *      necessary for TJ Pro clock control. The clock keeps track of    *
 *      milliseconds, seconds, minutes, hours, days and timertj.			*
 ************************************************************************/


/**************************** Includes **********************************/
#include <hc11.h>
#include <mil.h>
/************************************************************************/

/*************************** Prototypes *********************************/

#pragma interrupt_handler TOC1_isr
void TOC1_isr(void); /*Interrupt service routine to generate clock ticks*/
void init_clocktjp(void);/*Must be executed to enable clock routines*/
void wait(int);   /* Wait for int milliseconds */

/************************************************************************/


/***************************** Globals **********************************/

unsigned int msec, seconds, minutes, hours, days, timertjp;

/*
           Range
  msec:    0-999
  seconds: 0-59
  minutes: 0-59
  hours:   0-23
  days:    0-255

  timertjp:  0 to 65535 milliseconds

*/

/************************************************************************/

