/************************************************************************
 * 			MEKATRONIX Copyright 1998 		        *
 * Title        serialtp.h                                              *
 * Programmer   Keith L. Doty                                           *
 * Date         September 07,1998                                       *
 * Version      1                                                       *
 *                                                                      *
 * Description								*
 *	This header file refers to all routines and interrupt drivers   *
 *      necessary for TJ serial communication on the SCI. Object file is*
 *	in libtj.a and libsrtjp                                         *
 * IO Settings established by init_serial()                             *
 *      9600 baud, 8 bits, no parity, 1 stop bit, no flow of control.   *
 ************************************************************************/


#ifndef _SERIALTJ_H
#define _SERIALTJ_H

/**************************** Includes **********************************/

#include <hc11.h>
#include <mil.h>

/**************************** End of Includes ***************************/

/***************************** Prototypes *******************************/
void init_serial(void); /* Set up the SCI port  */

int read_int(); 
/* 
  Read(receive) an integer from the SCI port
  followed by a carriage_return and a line_feed.

  This function is not currently supported in ICC11 <stdio.h>.
*/



/*
 For all other serial IO operations use printf(), getchar(), putchar()
 in <stdio.h>
*/



#endif
