/**********************************************************************
 * Title        servotjp.h  (Servo Drivers for TJ PRO)                *
 * Programmer   Keith L. Doty			                      *
 * Date         September 15, 1998                                    *
 * Version      1                                                     *
 *                                                                    *
 * Description: Servo drivers based on the TJ standard drivers.       *
 * History:     Based on earlier versions by Greene, Doty, Bagnell.   *
 **********************************************************************/


/**************************** Includes **********************************/
#include <hc11.h>
#include <mil.h>
/************************************************************************/


/**************************** Constants *********************************/
#define HALFPERIOD 20000         /* 50Hz refresh for each servo */
/************************************************************************/


/*************************** Prototypes *********************************/
#pragma interrupt_handler TOC4_isr
void init_servotjp(void);

/* Arguments: Servo# (0,1,2), Pulse Width(0 or 2000 to 4000) */
void servo(int, int); 
 
void servo_hand(void);
/************************************************************************/



 