/**********************************************************************
 * 			MEKATRONIX Copyright 1998 		      *
 * Title            tjpbase.h    	                              *
 * Programmer       Keith L. Doty                                     *
 * Date             September 15, 1998                                *
 * Version          1.0                                               *
 *                                                                    *
 * Description							      *
 *   Collects include files and general constants into one file.      *
 **********************************************************************/

/*************************** Includes ********************************/

#include <analog.h>
#include <clocktjp.h>
#include <motortjp.h>
#include <serialtp.h>
#include <isrdecl.h>
#include <vectors.h>

/************************ End of Includes ****************************/

/**************************** Constants *********************************/
#define LEFT_MOTOR	0
#define RIGHT_MOTOR	1
#define MAX_SPEED      100
#define ZERO_SPEED       0

/*Analog Port assignments for TJ PRO*/
#define BUMPER     analog(0)
#define RIGHT_IR   analog(2)
#define LEFT_IR    analog(3)

#define START 	while(BUMPER<120) /*Back bumper often used for start switch*/
#define FRONT_BUMP  (BUMPER>10)&&(BUMPER< 120)
#define BACK_BUMP  BUMPER>120

/*Turn the IR emitters ON and OFF*/
#define IRE_ON  *(unsigned char *)(0x7000) = 0x07
#define IRE_OFF	*(unsigned char *)(0x7000) = 0x00

/************************ End of Constants ****************************/
