	.include "long.h"

	.area text
__ladd::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd	LO1,x
	addd LO2,x
	std LO1,x
	ldd HI1,x
	adcb HI2+1,x
	adca HI2,x
	std HI1,x
  ldab #8
  abx
	pula
	pulb
	rts

__lsub::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd LO1,x
	subd LO2,x
	std LO1,x
	ldd HI1,x
	sbcb HI2+1,x
	sbca HI2,x
	std HI1,x
  ldab #8
  abx
	pula
	pulb
	rts
__lsub_x:
	pshb
	psha
	ldd LO1,x
	subd LO2,x
	std LO1,x
	ldd HI1,x
	sbcb HI2+1,x
	sbca HI2,x
	std HI1,x
	pula
	pulb
	rts
;
;  AB
; *CD
;-----
;  Lo = Lo(B*D)
;  Hi = Hi(B*D) + Lo(C*B) + Lo(D*A)

__lmul::
	pshb
	psha
	pshy
  xgdx
  subd #8
  xgdx

	pshx
	pshx	; allocate temp
  ; (B * D)
	ldd LO1,x
	ldy LO2,x
	jsr __mulu
	pshy		; save HI(B*D)
	tsy
	iny
	iny
	std LOY,y
  ; B * C
	ldd LO1,x
	ldy HI2,x
	jsr __mulu
  ; d = Lo(B*C), save it
	pshb
	psha
  ; A*D
	ldd HI1,x
	ldy LO2,x
	jsr __mulu
  ; + LO(B*C) + Hi(B*D)
	tsy
	addd 0,y
	puly
	tsy
	addd 0,y
	puly
	tsy
	std HI1,x
	ldd LOY,y
	std LO1,x
	puly
	puly	; deallocate temp

  ldab #8
  abx
	puly
	pula
	pulb
	rts

; unsigned
; lreg /= lreg2
; remainder --> 0,y
udivrem:
	ldd #0
	std HIY,y
	std LOY,y
	ldab #32
divloop:
	pshb
	lsl LO1+1,x
	rol LO1,x
	rol HI1+1,x
	rol HI1,x
	rol LOY+1,y
	rol LOY,y
	rol HIY+1,y
	rol HIY,y

	ldd HIY,y
	cpd HI2,x 
	beq	NotFitInHigh
	blo NotFitIn
	ldd LOY,y
	bra FitIn
NotFitInHigh:
	ldd LOY,y
	cpd LO2,x
	blo NotFitIn
FitIn:
	subd LO2,x
	std LOY,y

	ldd HIY,y
	sbcb HI2+1,x
	sbca HI2,x
	std HIY,y

	inc LO1+1,x

NotFitIn:
	pulb
	decb
	bne divloop
	rts

; signed
; lreg /= lreg2
; remainder --> 0,y
divrem:
	ldd HI1,x
	eorb HI2+1,x
	eora HI2,x
	bpl same_sign
	ldab #1
	bra cont
same_sign:
	ldab #0
cont:
	pshb
	ldd HI1,x
	bpl OK1
	jsr __lneg_x
OK1:
	ldd HI2,x
	bpl OK2
	jsr __lneg2_x
OK2:
	jsr udivrem
	pulb
	tstb
	beq done_divrem
	jsr __lneg_x
done_divrem:
	rts

__ldiv::
	pshb
	psha
	pshy
  xgdx
  subd #8
  xgdx

	pshy
	pshy	; allocate temp
	tsy
	bsr divrem
	puly
	puly	; deallate temp

  ldab #8
  abx
	puly
	pula
	pulb
	rts

__ludiv::
	pshb
	psha
	pshy
  xgdx
  subd #8
  xgdx

	pshy
	pshy	; allocate temp
	tsy
	jsr udivrem
	puly
	puly	; deallocate temp

  ldab #8
  abx
	puly
	pula
	pulb
	rts

__lmod::
	pshb
	psha
	pshy
  xgdx
  subd #8
  xgdx

	pshy
	pshy	; allocate temp
	tsy
	jsr divrem
	jsr __ly2reg_x
	puly
	puly	; deallocate temp

  ldab #8
  abx
	puly
	pula
	pulb
	rts

__lumod::
	pshb
	psha
	pshy
  xgdx
  subd #8
  xgdx

	pshy
	pshy	; allocate temp
	tsy
	jsr udivrem
	jsr __ly2reg_x
	puly
	puly	; deallocate temp

  ldab #8
  abx
	puly
	pula
	pulb
	rts

__llsh::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldab LO2+1,x
	andb #31
xlshloop:
	tstb
	beq xdone
	lsl LO1+1,x
	rol LO1,x
	rol HI1+1,x
	rol HI1,x
	decb
	bra xlshloop
xdone:
  ldab #8
  abx
	pula
	pulb
	rts

__lilsh::
  xgdx
  subd #8
  xgdx
	andb #31
lshloop:
	tstb
	beq done
	lsl LO1+1,x
	rol LO1,x
	rol HI1+1,x
	rol HI1,x
	decb
	bra lshloop
done:
  ldab #8
  abx
	rts

__lrsh::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldab LO2+1,x
	andb #31
xrshloop:
	tstb
	beq xrsh_done
	asr HI1,x
	ror HI1+1,x
	ror LO1,x
	ror LO1+1,x
	decb
	bra xrshloop
xrsh_done:
  ldab #8
  abx
	pula
	pulb
	rts

__lirsh::
  xgdx
  subd #8
  xgdx
	andb #31
rshloop:
	tstb
	beq rsh_done
	asr HI1,x
	ror HI1+1,x
	ror LO1,x
	ror LO1+1,x
	decb
	bra rshloop
rsh_done:
  ldab #8
  abx
	rts

__lursh::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldab LO2+1,x
	andb #31
xurshloop:
	tstb
	beq xursh_done
	lsr HI1,x
	ror HI1+1,x
	ror LO1,x
	ror LO1+1,x
	decb
	bra xurshloop
xursh_done:
  ldab #8
  abx
	pula
	pulb
	rts

__luirsh::
  xgdx
  subd #8
  xgdx
	andb #31
urshloop:
	tstb
	beq ursh_done
	lsr HI1,x
	ror HI1+1,x
	ror LO1,x
	ror LO1+1,x
	decb
	bra urshloop
ursh_done:
  ldab #8
  abx
	rts

__land::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd HI1,x
	andb HI2+1,x
	anda HI2,x
	std HI1,x
	ldd LO1,x
	andb LO2+1,x
	anda LO2,x
	std LO1,x
  ldab #8
  abx
	pula
	pulb
	rts

__lor::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd HI1,x
	orab HI2+1,x
	oraa HI2,x
	std HI1,x
	ldd LO1,x
	orab LO2+1,x
	oraa LO2,x
	std LO1,x
  ldab #8
  abx
	pula
	pulb
	rts

__lxor::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd HI1,x
	eorb HI2+1,x
	eora HI2,x
	std HI1,x
	ldd LO1,x
	eorb LO2+1,x
	eora LO2,x
	std LO1,x
  ldab #8
  abx
	pula
	pulb
	rts

__lneg::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd #0
	subd LO1,x
	std LO1,x
	ldd #0
	sbcb HI1+1,x
	sbca HI1,x
	std HI1,x
  ldab #8
  abx
	pula
	pulb
	rts

__lneg2::
	pshb
	psha
  xgdx
  subd #8
  xgdx
	ldd #0
	subd LO2,x
	std LO2,x
	ldd #0
	sbcb HI2+1,x
	sbca HI2,x
	std HI2,x
  ldab #8
  abx
	pula
	pulb
	rts

__lneg_x:
	pshb
	psha
	ldd #0
	subd LO1,x
	std LO1,x
	ldd #0
	sbcb HI1+1,x
	sbca HI1,x
	std HI1,x
	pula
	pulb
	rts

__lneg2_x:
	pshb
	psha
	ldd #0
	subd LO2,x
	std LO2,x
	ldd #0
	sbcb HI2+1,x
	sbca HI2,x
	std HI2,x
	pula
	pulb
	rts

__lcom::
  xgdx
  subd #8
  xgdx
	com HI1+1,x
	com HI1,x
	com LO1+1,x
	com LO1,x
  ldab #8
  abx
	rts

; compare
; set condition code
; use stack for condition code result temp
__lcmp::
	pshb
	psha
	pshy
  xgdx
  subd #8
  xgdx

	pshy
	pshy	; allocate temp
	tsy
	jsr __lreg2y_x	; save a
	jsr __lsub_x
	tpa
	anda #0xF0
	psha	; save cc
  ; Result = lreg, A = (y), B = lreg2
; compute Z bit
	ldd HI1,x
	bne notzero
	ldd LO1,x
	bne notzero
	pula
	oraa #0x4	; Z
	psha
notzero:
; compute N bit
	ldd HI1,x
	beq notneg
	bpl notneg
	pula
	oraa #0x8	; N
	psha
notneg:
; compute C bit
	ldd HI2,x
	cpd HIY,y
	bhi carry
	blo nocarry
	ldd LO2,x
	cpd LOY,y
	bls nocarry
carry:
	pula
	oraa #0x1	; C
	psha
nocarry:
; Compute V bit
;  be careful that ldd sets the N flag, but not the C flag
	ldd HI1,x
	bmi	case2
	; R15 is pos, V is on iff
	;   op1 is neg and op2 is pos
	ldd HIY,y
	cpd #0
	bhs nooverflow
	ldd HI2,x
	bmi nooverflow
	bra overflow
case2:
	; R15 is neg, V is on iff
	;   op1 is pos and op2 is neg
	ldd HIY,y
	bmi nooverflow
	ldd HI2,x
	cpd #0
	bhs nooverflow
overflow:
	pula
	oraa #0x2
	psha
nooverflow:
  ldab #8
  abx
	pula
	tap

	puly
	puly	; deallocate temp

	puly
	pula
	pulb
	rts
