/* write a byte to the eeprom location */
#define _EEPROM
#include <hc11.h>


#define EEBYTE  bit(4)
#define EEERASE bit(2)

/* internal eeprom cannot be written while running code out of int. eeprom.
 * This code must be run from RAM or EPROM
 */
void write_eeprom(unsigned char *addr, unsigned char c)
        {
        if (*addr == c)
                return;
        INTR_OFF();
        PPROG = EEBYTE|EEERASE|EELAT;
        *addr = c;
        PPROG |= EEPGM;                 /* erase byte */
        asm(" ldy #2857");              /* delay 10 msecs */
        asm("xxL1: dey");
        asm(" bne xxL1");
        PPROG = 0;

        PPROG = EELAT;
        *addr = c;
        PPROG |= EEPGM;                 /* write new data */
        asm(" ldy #2857");              /* delay 10 msecs */
        asm("xxL2: dey");
        asm(" bne xxL2");
        PPROG = 0;
        INTR_ON();
        }
