#include <stdio.h>
#include <tjpbase.h>
#include <algconst.h>

#pragma interrupt_handler PAV_isr

void PAV_isr(void);
void init_PA(void);
void TURN_RIGHT(void);

int speedr, speedl, counter, done;

void main(void)
{
	init_analog();
	init_motortjp();
	init_clocktjp();
	init_PA();

	while(1)
	{
		START;
		
		counter=0;
		PACNT=0x00;

		TURN_RIGHT();
	
	}
}
	
	
void TURN_RIGHT(void)
{
			counter=1;
			PACNT=0x80;
			done=0;
			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}

//		printf("\nNumber of overflows: %d\n",counter);
//		printf("PACNT - %d\n",PACNT);

			counter=1;
			PACNT = 0x40;			
			done=0;
			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}
			
//		printf("\nNumber of overflows: %d\n",counter);
//		printf("PACNT - %d\n",PACNT);

			counter=1;
			PACNT = 0x80;
			done=0;			
			motorp(RIGHT_MOTOR, MAX_RIGHT);
			motorp(LEFT_MOTOR, MAX_LEFT);
			while(done==0)
			{
				asm("NOP");
			}
			

//		printf("\nNumber of overflows: %d\n",counter);
//		printf("PACNT - %d\n",PACNT);

			motorp(RIGHT_MOTOR, 0);
			motorp(LEFT_MOTOR, 0);			
}


void init_PA(void)
{
	INTR_OFF();

	CLEAR_BIT(PACTL, 0xB0); /*Set for input, counting, and catch falling edges*/
	SET_BIT(PACTL, 0x40); /*Enable PA*/
	

	CLEAR_FLAG(TFLG2, 0x20); /* Clear flag */
	SET_BIT(TMSK2, 0x20); /* Enable PA Overflow interrupt */

	PACNT=0x00;

	INTR_ON();
}

void PAV_isr(void)
{
	if(counter==0)
	{
		motorp(RIGHT_MOTOR,0);
		motorp(LEFT_MOTOR,0);
		done=1;
	}
	else
	{
		counter--;
	}
	
	CLEAR_FLAG(TFLG2, 0x20);
}